## composable-kernel 7.0.1

=== debian/changelog ===
composable-kernel (7.0.1-1~exp1) experimental; urgency=low

  * Initial release. Closes: #1117561

 -- Christian Bayle <bayle@debian.org>  Mon, 06 Oct 2025 14:31:31 +0200
