=== debian/control ===
Source: composable-kernel
Section: devel
Priority: optional
Maintainer: Debian ROCm Team <debian-ai@lists.debian.org>
Uploaders: Christian Bayle <bayle@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 pybuild-plugin-pyproject,
 python3-all,
 python3-setuptools,
 python3-setuptools-scm,
 cmake (>=4.1.2~),
 cmake-data (>=4.1.2~),
 rocm-cmake (>=6.4.0~),
 hipcc (>=6.4.0~),
 ninja-build,
 git,
 clang-tidy-21,
  zlib1g-dev,
  libzstd-dev,
  libnuma-dev,
  libbzip3-dev,
  libelf-dev,
  libdw-dev,
  rocm-device-libs-21,
  liblld-22,
  libhsakmt-dev,
  librocrand-dev,
  libsqlite3-dev,
   libamd-comgr-dev (>=6.4.0~),
   libamdhip64-dev (>=6.4.0~),
   libhiprtc-builtins6,
   libhsa-runtime-dev (>=6.4.0~),
  pkg-rocm-tools (>= 0.9.0~exp3),
   googletest,
  ccache,
Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
 python3-rocm-docs (>= 1.20.0-1~) <!nodoc>,
 libjs-mathjax <!nodoc>,
 libjs-jquery <!nodoc>,
 python3-doxysphinx <!nodoc>,
 python3-sphinx-external-toc <!nodoc>,
 python3-sphinxcontrib.bibtex <!nodoc>,
Standards-Version: 4.7.2
Homepage: https://github.com/ROCm/composable_kernel
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/rocm-team/composable-kernel.git
Vcs-Browser: https://salsa.debian.org/rocm-team/composable-kernel

Package: libcomposable-kernel-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el
XB-X-ROCm-GPU-Architecture: ${rocm:GPU-Architecture}
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Programming Model for ML Tensor Operators
 The Composable Kernel (CK) library provides a programming
 model for writing performance-critical kernels for machine
 learning workloads across multiple architectures
 (GPUs, CPUs, etc.).
 The CK library uses general purpose kernel languages,
 such as HIP C++.
 .
 CK uses two concepts to achieve performance portability
 and code maintainability:
 .
  * A tile-based programming model
  * Algorithm complexity reduction for complex machine learning (ML)
   operators. This uses an innovative technique called Tensor
   Coordinate Transformation.
 .
 The current CK library is structured into four layers:
 .
  * Templated Tile Operators
  * Templated Kernel and Invoker
  * Instantiated Kernel and Invoker
  * Client API

Package: libcomposable-kernel-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax,
         libjs-jquery,
Description: Programming Model for ML Tensor Operators (doc)
 The Composable Kernel (CK) library provides a programming
 model for writing performance-critical kernels for machine
 learning workloads across multiple architectures
 (GPUs, CPUs, etc.).
 The CK library uses general purpose kernel languages,
 such as HIP C++.
 .
 This package provides documentation

Package: python3-ck4inductor
Architecture: all
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
Description: Programming Model for ML Tensor Operators (Python)
 The Composable Kernel (CK) library provides a programming
 model for writing performance-critical kernels for machine
 learning workloads across multiple architectures
 (GPUs, CPUs, etc.).
 The CK library uses general purpose kernel languages,
 such as HIP C++.
 .
 This package provides Python interface

Package: libcomposable-kernel-tests
Section: libdevel
Architecture: amd64 arm64 ppc64el
XB-X-ROCm-GPU-Architecture: ${rocm:GPU-Architecture}
Depends: ${misc:Depends}, ${shlibs:Depends},
Build-Profiles: <!nocheck>
Description: Programming Model for ML Tensor Operators (tests)
 The Composable Kernel (CK) library provides a programming
 model for writing performance-critical kernels for machine
 learning workloads across multiple architectures
 (GPUs, CPUs, etc.).
 The CK library uses general purpose kernel languages,
 such as HIP C++.
 .
 This package provides test binaries
