=== debian/tests/control ===
Test-Command: rocm-test-launcher /usr/libexec/rocm/libcomposable-kernel-tests/run-tests
Features: test-name=composable-kernel-tests
Depends: pkg-rocm-tools, libcomposable-kernel-tests, rocminfo
Restrictions: skippable, allow-stderr
Architecture: amd64
